//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Udbplan.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DBPlanner"
#pragma link "Planner"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MonthCalendar1Click(TObject *Sender)
{
  DBDaySource1->Day = MonthCalendar1->Date;
  UpdateHeaders();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DBDaySource1FieldsToItem(TObject *Sender,
      TFields *Fields, TPlannerItem *Item)
{
   Item->Color = TColor(Fields->FieldByName("COLOR")->AsInteger);
   Item->CaptionBkg = Item->Color;
   Item->ImageID = Fields->FieldByName("IMAGE")->AsInteger;
   if (Fields->FieldByName("CAPTION")->AsBoolean)
     Item->CaptionType = ctTime;
   else
     Item->CaptionType = ctNone;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DBPlanner1ItemInsert(TObject *Sender, int Position,
      int FromSel, int FromSelPrecise, int ToSel, int ToSelPrecise)
{
  TPlannerItem *plIt;
  plIt = DBPlanner1->CreateItem();
  //take the settings from the Default item - just set properties below
  plIt->ItemBegin = FromSel;
  plIt->ItemEnd = ToSel;
  plIt->ItemPos = Position;
  plIt->Text->Text = "Item created at runtime on "+FormatDateTime("hh:nn dd/mm/yyyy",Now());
  plIt->Update();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DBPlanner1ItemDelete(TObject *Sender,
      TPlannerItem *Item)
{
  DBPlanner1->FreeItem(Item);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Table1AfterDelete(TDataSet *DataSet)
{
  DBDaySource1->SynchDBItems();
  DBDaySource2->SynchDBItems();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Color1Click(TObject *Sender)
{
  ColorDialog1->Color = DBPlanner1->PopupPlannerItem->Color;
  if (ColorDialog1->Execute())
  {
    DBPlanner1->PopupPlannerItem->Color = ColorDialog1->Color;
    DBPlanner1->PopupPlannerItem->CaptionBkg = ColorDialog1->Color;
    DBPlanner1->PopupPlannerItem->Update();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DBDaySource1ItemToFields(TObject *Sender,
      TFields *Fields, TPlannerItem *Item)
{
  Fields->FieldByName("COLOR")->AsInteger = Integer(Item->Color);
  Fields->FieldByName("CAPTION")->AsBoolean = (Item->CaptionType == ctTime);
  Fields->FieldByName("IMAGE")->AsInteger = Item->ImageID;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DBPlanner1ItemPopupPrepare(TObject *Sender,
      TPopupMenu *PopupMenu, TPlannerItem *Item)
{
  TMenuItem *MenuItem;

  MenuItem = ItemPopup->Items->Items[1];

  MenuItem->Checked = Item->CaptionType == ctTime;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Caption1Click(TObject *Sender)
{
  if (DBPlanner1->PopupPlannerItem->CaptionType == ctTime)
    DBPlanner1->PopupPlannerItem->CaptionType = ctNone;
  else
    DBPlanner1->PopupPlannerItem->CaptionType = ctTime;

  DBPlanner1->PopupPlannerItem->Update();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpdateHeaders(void)
{
  int i;
  TDateTime dt;

  DBPlanner1->Header->Captions->Clear();
  DBPlanner1->Header->Captions->Add("");
  for (i = 1; i <= 3; i++)
  {
    DBPlanner1->Header->Captions->Add(FormatDateTime("DDD dd/mm/yyyy",DBDaySource1->Day + i - 1 ));
  };
}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Table1->DatabaseName = GetCurrentDir();
  Table1->TableName = "plandb.db";
  Table1->Active = true;

  UpdateHeaders();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DBPlanner1PlannerNext(TObject *Sender)
{
  UpdateHeaders();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DBPlanner1PlannerPrev(TObject *Sender)
{
  UpdateHeaders();
}
//---------------------------------------------------------------------------

